#include "hpmetrinit.h"
#include "hpglobalc.h"
#include "xfile.h"
#include "stacktrace.h"

/**
   function reads all data from the input file
   
   @param argv - pointer to input file names
   
   TKr 29/07/2022
*/
void hpmetr_init (int argc,const char *argv[])
{
  long i,mpt;
  char name[1100];
  MPI_Status stat;
  const char *aux;
  
  //  names of input files
  strcpy (name,argv[1]);
  sprintf (&name[strlen (argv[1])],"%d.in",Myrank+1);
  aux = argv[1];
  argv[1] = name;

  //  reading of the classical METR input file
  metr_init (argc,(const char **)(argv));
  argv[1] = aux;
  
  
  if (Myrank==0){
    switch (Cp->tprob){
    case par_coupl_mech_trans:{
      mpt=10;
      break;
    }
    case fully_coupled_mech_trans:{
      mpt=1;
      break;
    }
    default:{
      print_err("unknown type of coupled problem is required ",__FILE__, __LINE__, __func__);
    }
    }

    for (i=1;i<Nproc;i++){
      MPI_Send (&mpt,1,MPI_LONG,i,Myrank,MPI_COMM_WORLD);
    }
  }
  else{
    MPI_Recv (&mpt,1,MPI_LONG,MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,&stat);
  }
  MPI_Barrier (MPI_COMM_WORLD);
  
  if (mpt==10){
    Mtprobc=par_coupl_mech_trans;
  }
  if (mpt==1){
    Mtprobc=fully_coupled_mech_trans;
  }
  fprintf (stdout,"\n procesor %d  mpt   %ld",Myrank,mpt);
  fflush (stdout);
}
